//+------------------------------------------------------------------+
//| ADX_Advanced_WA_mtf                          ADX_Advanced_WA.mq4 |
//|                              Copyright  2006, Eng. Waddah Attar |
//| (mtf ForexTSD.com 2007) mladen  ki       waddahattar@hotmail.com |
//+------------------------------------------------------------------+
#property copyright "Waddah Attar"
#property link      "waddahattar@hotmail.com"
//----
#property indicator_separate_window
#property indicator_buffers 2
#property indicator_color1 Green
#property indicator_color2 Red
#property indicator_style1    0
#property indicator_width1    2
#property indicator_style2    0
#property indicator_width2    2
#property indicator_level1 20
#property indicator_level2 30
#property indicator_levelcolor  SlateGray


//----
extern int ADXPeriod = 13;

extern int  MaxBarsToCount  =500;
extern int TimeFrame = 0;
extern string note_TimeFrames = "M1;5,15,30,60H1;240H4;1440D1;10080W1;43200MN|0-currentTF";
string IndicatorFileName;

//----
double ExtBuffer1[];
double ExtBuffer2[];
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
int init()
  {
   SetIndexBuffer(0, ExtBuffer1);
   SetIndexStyle(0, DRAW_HISTOGRAM);
//----
   SetIndexBuffer(1, ExtBuffer2);
   SetIndexStyle(1, DRAW_HISTOGRAM);


   SetIndexLabel(0,"ADX ("+ADXPeriod+")["+TimeFrame+"]");
   SetIndexLabel(1,"ADX ("+ADXPeriod+")["+TimeFrame+"]");



//----
   IndicatorFileName = WindowExpertName();
   
   IndicatorShortName("Advanced_ADX ("+ADXPeriod+") ["+TimeFrame+"]");
   if (TimeFrame < Period()) TimeFrame = Period();
 
   return(0);
  }
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
int start()
  {
 
 ////

   int      limit1,i1;

   int counted_bars1 = IndicatorCounted();
   if(counted_bars1 < 0) return(-1);
   limit1 = Bars-counted_bars1;

   //
   //
   //    MTF mode operating,  mladen
   //
   //

   if (TimeFrame != Period())
      {
        limit1= Bars-counted_bars1;
        limit1= MathMax(limit1,TimeFrame/Period());

         datetime TimeArray[];
            ArrayCopySeries(TimeArray ,MODE_TIME ,NULL,TimeFrame);
         
            //
            //
            //
            //
            //
         
            for(i1=0,int y=0; i1<limit1; i1++)
            {
               if(Time[i1]<TimeArray[y]) y++;
     
                     ExtBuffer1[i1]   = iCustom(NULL,TimeFrame,IndicatorFileName,0,y);
                     ExtBuffer2[i1]   = iCustom(NULL,TimeFrame,IndicatorFileName,1,y);
            //
            //
            //
            //
            //

            }
         return(0);         
      }
      
      //
      //
      //
      //
      //
  
   int i, limit;
   double ADX0,ADX1,ADX2;
   int counted_bars = IndicatorCounted();
   if(counted_bars < 0) 
       return(-1);
   if(counted_bars > 0) 
       counted_bars--;
   limit = Bars - counted_bars; 
   limit= MathMin(limit,MaxBarsToCount);  

//----   
   for(i = 0; i < limit ; i++)
     {
       ADX0 = iADX(NULL, 0, ADXPeriod, PRICE_CLOSE, MODE_MAIN, i);
       ADX1 = iADX(NULL, 0, ADXPeriod, PRICE_CLOSE, MODE_PLUSDI, i);
       ADX2 = iADX(NULL, 0, ADXPeriod, PRICE_CLOSE, MODE_MINUSDI, i);
       //----
       if(ADX1 >= ADX2)
         {
           ExtBuffer1[i] = ADX0;
           ExtBuffer2[i] = 0;
         }
       else
         {
           ExtBuffer1[i] = 0;
           ExtBuffer2[i] = ADX0;
         }
     }
   return(0);
  }
//+------------------------------------------------------------------+

